!-----------------------------------------------------------
!  Move particles with OHgen(*,1) = 999.0 (i.e., those out
!  of [sg(1),sg(num+1)] to above particles within [sg(1), 
!  sg(num+1)] in the array OHgen(*,3)
!
!  Feb 20, 2003. Jiannan Tu. Modified 3/25/10
!-----------------------------------------------------------
subroutine compind1(imax,OHgen)
    integer imax,itp,j

    real(8), dimension(imax,3) :: OHgen

    itp=imax
    j=1
    do while (j.lt.itp)
        if (OHgen(j,1).gt.900.0d0) then
            do while(OHgen(itp,1).gt.900.0d0.and.itp.gt.j)
                itp=itp-1
            enddo

            if(itp.eq.j) then
                itp=itp-1
            else
                OHgen(j,1)=OHgen(itp,1)
                OHgen(j,2)=OHgen(itp,2)
                OHgen(j,3)=OHgen(itp,3)
                OHgen(itp,1)=999.0d0
            endif
        endif
        j=j+1
    enddo
    if(itp.gt.0.and.OHgen(itp,1).gt.900.0d0) itp=itp-1
    imax=itp

end subroutine


!-----------------------------------------------------------
!  save particles in the corresponding cells
!  Aug. 6, 2010 Yan Wang
!-----------------------------------------------------------
subroutine compind2(imax,OHgen,dummy1,dummy2,dummy4,dummy5)

    use gskparm
    integer imax,j,i,ind1,ind2,ind3,ind4,ind5,ind6
    real(8) s

    real(8), dimension(np,3) :: OHgen,dummy3
    real(8), dimension(np1,3) :: dummy1,dummy2,dummy4,dummy5

    integer rank,ierr,status
    common /mpi/rank,ierr,status

    dummy1(1:np1,1)=999.0d0; dummy2(1:np1,1)=999.0d0
    dummy4(1:np1,1)=999.0d0; dummy5(1:np1,1)=999.0d0
    dummy3(1:np,1)=999.0d0
    j=rank
    ind1=0;ind2=0;ind3=0;ind4=0;ind5=0;ind6=0

    if(j.eq.0) then
        
        do i=1,imax
            s=OHgen(i,1)
            if(s.ge.sg(1).and.s.lt.sg(2)) then
                ind3=ind3+1
                dummy3(ind3,1:3)=OHgen(i,1:3);
            else if(s.ge.sg(2).and.s.lt.sg(3)) then
                ind4=ind4+1
                if(ind4.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j 
                   stop
                endif
                dummy4(ind4,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(3).and.s.lt.sg(4)) then
                ind5=ind5+1
                if(ind5.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy5(ind5,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(4)) then
                ind6=ind6+1
                if(ind6.gt.400) then
                write(*,*) 'too many particles in rank=', j,'move across the defined boundary'
                stop
                endif
            endif
        enddo
    endif

    if(j.eq.1) then
        
        do i=1,imax
            s=OHgen(i,1)
            if(s.ge.sg(1).and.s.lt.sg(2)) then
                ind2=ind2+1
                if(ind2.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy2(ind2,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(2).and.s.lt.sg(3)) then
                ind3=ind3+1
                dummy3(ind3,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(3).and.s.lt.sg(4)) then
                ind4=ind4+1
                if(ind4.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy4(ind4,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(4).and.s.lt.sg(5)) then
                ind5=ind5+1
                if(ind5.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy5(ind5,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(5)) then
                ind6=ind6+1
                if(ind6.gt.400)then
                  write(*,*) 'too many particles in rank=', j,'move across the defined boundary'
                  stop
                endif
            endif
        enddo
    endif


    if(j.eq.num-2) then
        
        do i=1,imax
            s=OHgen(i,1)
            if(s.ge.sg(j-1).and.s.lt.sg(j)) then
                ind1=ind1+1
                if(ind1.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy1(ind1,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j).and.s.lt.sg(j+1)) then
                ind2=ind2+1
                if(ind2.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy2(ind2,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j+1).and.s.lt.sg(j+2)) then
                ind3=ind3+1
                dummy3(ind3,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j+2).and.s.lt.sg(j+3)) then
                ind4=ind4+1
                if(ind4.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy4(ind4,1:3)=OHgen(i,1:3)
            else if(s.lt.sg(j-1)) then
                ind6=ind6+1
                if(ind6.gt.400)then
                write(*,*) 'too many particle in rank=', j,'move across the defined boundary'
                stop
                endif
            endif
        enddo
    endif

    if(j.eq.num-1) then
        
        do i=1,imax
            s=OHgen(i,1)
            if(s.ge.sg(j-1).and.s.lt.sg(j)) then
                ind1=ind1+1
                if(ind1.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy1(ind1,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j).and.s.lt.sg(j+1)) then
                ind2=ind2+1
                if(ind2.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy2(ind2,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j+1).and.s.lt.sg(j+2)) then
                ind3=ind3+1
                dummy3(ind3,1:3)=OHgen(i,1:3)
            else if(s.lt.sg(j-1)) then
                ind6=ind6+1
                if(ind6.gt.400) then
                write(*,*) 'too many particles in rank=', j,'move across the defined boundary'
                stop
                endif
            endif
        enddo
    endif

    if(j.ge.2.and.j.le.num-3) then
        
        do i=1,imax
            s=OHgen(i,1)
            if(s.ge.sg(j-1).and.s.lt.sg(j)) then
                ind1=ind1+1
                if(ind1.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy1(ind1,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j).and.s.lt.sg(j+1)) then
                ind2=ind2+1
                if(ind2.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy2(ind2,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j+1).and.s.lt.sg(j+2)) then
                ind3=ind3+1
                dummy3(ind3,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j+2).and.s.lt.sg(j+3)) then
                ind4=ind4+1
                if(ind4.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy4(ind4,1:3)=OHgen(i,1:3)
            else if(s.ge.sg(j+3).and.s.lt.sg(j+4)) then
                ind5=ind5+1
                if(ind5.gt.np1) then
                   write(*,*) 'Too many particles move out in compind2 rank=',j
                   stop
                endif
                dummy5(ind5,1:3)=OHgen(i,1:3)
            endif
            if(s.lt.sg(j-1).or.s.ge.sg(j+4)) then
                ind6=ind6+1
                if(ind6.gt.400) then
                write(*,*) 'particle in rank=', j,'move across the defined boundary'
                stop
                endif
            endif
        enddo
    endif



    OHgen(1:np,1)=dummy3(1:np,1)
    OHgen(1:np,2)=dummy3(1:np,2)
    OHgen(1:np,3)=dummy3(1:np,3)
    imax=ind3


end subroutine compind2

!-----------------------------------------------------------
!  compind particles coming from other cells
!  Jun. 8, 2011 Yan Wang
!-----------------------------------------------------------
subroutine compind3(imax,OHgen,dummy1,dummy2,dummy4,dummy5)

    use gskparm
    integer imax,j,i,ind1,ind2,ind3,ind4,ind5
    real(8) s

    real(8), dimension(np,3) :: OHgen,dummy3
    real(8), dimension(np1,3) :: dummy1,dummy2,dummy4,dummy5

    integer rank,ierr,status
    common /mpi/rank,ierr,status

    j=rank

    do i=1,np1
       s=dummy1(i,1)
       if(s.ge.sg(j+1).and.s.lt.sg(j+2)) then
         imax=imax+1
         if(imax.gt.np) then
            write(*,*) 'too many particles in rank=',j,'in compind3'
            stop
         endif
         OHgen(imax,1)=dummy1(i,1)
         OHgen(imax,2)=dummy1(i,2)
         OHgen(imax,3)=dummy1(i,3)
       endif
    enddo

    do i=1,np1
       s=dummy2(i,1)
       if(s.ge.sg(j+1).and.s.lt.sg(j+2)) then
         imax=imax+1
         if(imax.gt.np) then
            write(*,*) 'too many particles in rank=',j,'in compind3'
            stop
         endif
         OHgen(imax,1)=dummy2(i,1)
         OHgen(imax,2)=dummy2(i,2)
         OHgen(imax,3)=dummy2(i,3)
       endif
    enddo

    do i=1,np1
       s=dummy4(i,1)
       if(s.ge.sg(j+1).and.s.lt.sg(j+2)) then
         imax=imax+1
         if(imax.gt.np) then
            write(*,*) 'too many particles in rank=',j,'in compind3'
            stop
         endif
         OHgen(imax,1)=dummy4(i,1)
         OHgen(imax,2)=dummy4(i,2)
         OHgen(imax,3)=dummy4(i,3)
       endif
    enddo


    do i=1,np1
       s=dummy5(i,1)
       if(s.ge.sg(j+1).and.s.lt.sg(j+2)) then
         imax=imax+1
         if(imax.gt.np) then
            write(*,*) 'too many particles in rank=',j,'in compind3'
            stop
         endif
         OHgen(imax,1)=dummy5(i,1)
         OHgen(imax,2)=dummy5(i,2)
         OHgen(imax,3)=dummy5(i,3)
       endif
    enddo

end subroutine compind3
