subroutine interpol(jb1,jb2)
    use gskparm

    real(8) N(4,401),TI(3,401),F(20),U(2,401),BG(401),BM(401)
    real(8) GR(2,401),R(2,401),SL(401),UE(2,401),GL(401)
    real(8) OPLS(401),VOPLS(401),HE(401),HEPRD(401),OP(401)

    real(8),dimension(nc)::dens_O,vels_O,tprs_O,dens_H,vels_H,tprs_H
    real(8),dimension(nc)::dens_He,vels_He,tprs_He,tprs_e

    integer i,num1,IDAY,jb1,jb2,jmax1

    real(8) NO(jb2-jb1+1),NH(jb2-jb1+1),VO(jb2-jb1+1),VH(jb2-jb1+1)
    real(8) TsO(jb2-jb1+1),TsH(jb2-jb1+1),Tse(jb2-jb1+1)
    real(8) NHe(jb2-jb1+1),VHe(jb2-jb1+1),TsHe(jb2-jb1+1)
    real(8) CLD(jb2-jb1+1), dCL(jb2-jb1),thet(nc),raddeg
    real(4) AP(7),DEC,ETRAN,BLON,F107,F107A,SEC

    COMMON/FJS/N,TI,F
    COMMON/VN/U,BG,BM,GR,R,SL
    COMMON/A/OPLS,VOPLS,HE,UE,HEPRD,OP
    COMMON/MSIS/AP,DEC,ETRAN,BLON,F107,F107A,IDAY,SEC,GL

    raddeg=180.0d0/acos(-1.d0)
    num1=num+1
    jmax1=jb2-jb1+1

    CLD(1:jmax1)=90.0d0-GL(jb1:jb2)*raddeg
    thet(1:num1)=90.0d0-GLL(1:num1)*raddeg

    do i=1,jmax1-1
      dCL(i)=CLD(i+1)-CLD(i)
    enddo

    NO(1:jmax1)=N(1,jb1:jb2)
    NH(1:jmax1)=N(2,jb1:jb2)
    NHe(1:jmax1)=N(4,jb1:jb2)
    VO(1:jmax1)=U(1,jb1:jb2)/100.0d0
    VH(1:jmax1)=U(2,jb1:jb2)/100.0d0
    VHe(1:jmax1)=UE(1,jb1:jb2)/100.0d0
    TsO(1:jmax1)=Ti(1,jb1:jb2)
    TsH(1:jmax1)=Ti(2,jb1:jb2)
    TsHe(1:jmax1)=Ti(2,jb1:jb2)
    Tse(1:jmax1)=Ti(3,jb1:jb2)

    do i=1,num1
      call lgrg(CLD,NO,jmax1,thet(i),dens_O(i))
      call lgrg(CLD,VO,jmax1,thet(i),vels_O(i))
      call lgrg(CLD,TsO,jmax1,thet(i),tprs_O(i))

      call lgrg(CLD,NH,jmax1,thet(i),dens_H(i))
      call lgrg(CLD,VH,jmax1,thet(i),vels_H(i))
      call lgrg(CLD,TsH,jmax1,thet(i),tprs_H(i))

      call lgrg(CLD,Tse,jmax1,thet(i),tprs_e(i))

      call lgrg(CLD,NHe,jmax1,thet(i),dens_He(i))
      call lgrg(CLD,VHe,jmax1,thet(i),vels_He(i))
      call lgrg(CLD,TsHe,jmax1,thet(i),tprs_He(i))
    enddo

    do i=1,num
        den_O(i)=0.5*(dens_O(i)+dens_O(i+1))
        vel_O(i)=0.5*(vels_O(i)+vels_O(i+1))
        tpr_O(i)=0.5*(tprs_O(i)+tprs_O(i+1))
        den_H(i)=0.5*(dens_H(i)+dens_H(i+1))
        vel_H(i)=0.5*(vels_H(i)+vels_H(i+1))
        tpr_H(i)=0.5*(tprs_H(i)+tprs_H(i+1))
        tpr_e(i)=0.5*(tprs_e(i)+tprs_e(i+1))
        den_He(i)=0.5*(dens_He(i)+dens_He(i+1))
        vel_He(i)=0.5*(vels_He(i)+vels_He(i+1))
        tpr_He(i)=0.5*(tprs_He(i)+tprs_He(i+1))
    enddo


    den_e(1:num)=den_O(1:num)+den_H(1:num)+den_He(1:num)
    vel_e(1:num)=(den_O(1:num)*vel_O(1:num)+den_H(1:num)* &
        vel_H(1:num)+den_He(1:num)*vel_He(1:num))/den_e(1:num)

    den_O(num+1)=0.0; vel_O(num+1)=0.0; tpr_O(num+1)=0.0
    den_H(num+1)=0.0; vel_H(num+1)=0.0; tpr_H(num+1)=0.0
    den_e(num+1)=0.0; vel_e(num+1)=0.0; tpr_e(num+1)=0.0
    den_He(num+1)=0.0; vel_He(num+1)=0.0; tpr_He(num+1)=0.0

!    open(888,file='test.dat')
!    do i=1,num1
!      write(888,'(10e15.6)') GLL(i)*raddeg,tpr_e(i),tpr_O(i),tpr_H(i), &
!            den_O(i),den_H(i),den_He(i),vel_O(i),vel_H(i),vel_He(i)
!    enddo
!    close(888)

    if(empt == 0) then
        ! start from an empty flux.
        den_e(2:num)=0.0
        vel_e(2:num)=0.0
        tpr_e(2:num)=0.0
        den_O(2:num)=0.0
        den_H(2:num)=0.0
        den_He(2:num)=0.0
        tpr_O(2:num)=0.0
        tpr_H(2:num)=0.0
        tpr_He(2:num)=0.0
        vel_O(2:num)=0.0
        vel_H(2:num)=0.0
        vel_He(2:num)=0.0
    endif

    tpp_e=tpr_e
    tpp_O=tpr_O
    tpp_H=tpr_H
    tpp_He=tpr_He

end subroutine
