!-----------------------------------------------------------------------
!  Move Hydrog simulation particles
!-----------------------------------------------------------------------
subroutine move_Hydrog(efield,dpph)
    use gskparm

    real(8), dimension(nc) :: efield,dpph
    real(8) :: am_h,s,vs,vp,qmrH,ran2

    integer :: i,j,nnew

    integer rank,ierr,status
    common /mpi/rank,ierr,status


    DATA am_h/1.67382304d-27/,qmrH/15.0240129d0/

! Consider particles newly produced (by O+ + H reaction), and injdected
! from FLIP region
!-----------------------------------------------------------------------
! P_H(i): H+ from O+ + H reaction in full 4 seconds.
!-----------------------------------------------------------------------

        ! newly produced H+ by O+ + H reaction; having initial
        ! Maxwell distribution of hydrogen
        nnew=P_H(rank+1)+ran2(iseed)
        if (nnew.gt.0) call neutral_produced(rank+1,imax_H,vt_H,nnew,Hydrog)

    P_H=0.0d0

    do j=1,imax_H
        s=Hydrog(j,1)

        ! ignore the ptcl that is out of range
        if(s.lt.sg(1).or.s.ge.sg(num+1)) cycle

        vs=Hydrog(j,2)
        vp=Hydrog(j,3)

        ! heating by electron
!        call addheat(i,s,vs,am_h,dtg,den_e,tpr_e,den_H,tpr_H,0)
!        call addheat(i,s,vp,am_h,dtg,den_e,tpp_e,den_H,tpp_H,1)

        !X.Y.WU03/05/98 wave-induced heating
        if(dpph(rank+1).gt.0.0d0) call waveheat(rank+1,s,vp,dpph,dtg,am_h)

        ! react with O (only for < 5000 km when den_aO substantial)
        !if(alt(i).lt.5000.0d0) call react_aO(i,s,vs,vp,dtg)

        ! move particle subjeted to various forces
        !vs1=vs
        if(s.ge.sg(rank+1).and.s.lt.sg(rank+2)) then
            call mover(rank+1,efield,s,vs,vp,dtg,qmrH)
        endif

        ! keeping all particles (including s=999)
        Hydrog(j,1)=s
        Hydrog(j,2)=vs
        Hydrog(j,3)=vp
    enddo

! compact H+ indice
    call compind1(imax_H,Hydrog)

end subroutine move_Hydrog
