!--------------------------------------------------------------------
!  Write O+, H+, He+ & e moments, efield, poten, wave heating rate to
!  output files
!
!  Jiannan Tu 4/8/2010
!--------------------------------------------------------------------
subroutine print_moments(nst,efield,poten,curt,dppo,dpph,dpphe)

    use inparm
    use gskparm

    real(8) poten(nc),efield(nc),curt(nc),dppo(nc),dpph(nc),dpphe(nc)

    integer nst,i,j,num1
    !real(8) s

    num1=num+1

!.... Smooth to reduce the noise
    call smoothp(den_O,num)
    call smoothp(vel_O,num)
    call smoothp(tpr_O,num)
    call smoothp(tpp_O,num)
    call smoothp(qpr_O,num)
    call smoothp(qpp_O,num)
    call smoothp(den_H,num)
    call smoothp(vel_H,num)
    call smoothp(tpr_H,num)
    call smoothp(tpp_H,num)
    call smoothp(qpr_H,num)
    call smoothp(qpp_H,num)
    call smoothp(den_He,num)
    call smoothp(vel_He,num)
    call smoothp(tpr_He,num)
    call smoothp(tpp_He,num)
    call smoothp(qpr_He,num)
    call smoothp(qpp_He,num)
    call smoothp(den_e,num)
    call smoothp(vel_e,num)
    call smoothp(tpr_e,num)
    call smoothp(tpp_e,num)
    call smoothp(qpr_e,num)
    call smoothp(qpp_e,num)
    !call smoothp(efield,num1)
    !call smoothp(poten,num1)

    do i=1,num
        write(201,'(8es14.5)') sngl((alt(i)+alt(i+1))/2.0),sngl((GLL(i)+GLL(i+1))*57.29578/2.0), &
               sngl(den_O(i)),sngl(vel_O(i)), &
               sngl(tpr_O(i)),sngl(tpp_O(i)), &
               sngl(qpr_O(i)),sngl(qpp_O(i))
        write(202,'(8es14.5)') sngl((alt(i)+alt(i+1))/2.0),sngl((GLL(i)+GLL(i+1))*57.29578/2.0), &
               sngl(den_H(i)),sngl(vel_H(i)), &
               sngl(tpr_H(i)),sngl(tpp_H(i)), &
               sngl(qpr_H(i)),sngl(qpp_H(i))
        write(203,'(8es14.5)') sngl((alt(i)+alt(i+1))/2.0),sngl((GLL(i)+GLL(i+1))*57.29578/2.0), &
               sngl(den_e(i)),sngl(vel_e(i)),sngl(tpr_e(i)), &
               sngl(tpp_e(i)),sngl(qpr_e(i)),sngl(qpp_e(i))
        write(204,'(8es14.5)') sngl((alt(i)+alt(i+1))/2.0),sngl((GLL(i)+GLL(i+1))*57.29578/2.0), &
               sngl(den_He(i)),sngl(vel_He(i)), &
               sngl(tpr_He(i)),sngl(tpp_He(i)), &
               sngl(qpr_He(i)),sngl(qpp_He(i))

        write(205,'(7es14.5)') sngl((alt(i)+alt(i+1))/2.0),sngl((GLL(i)+GLL(i+1))*57.29578/2.0), &
               sngl(efield(i)),sngl(poten(i)),sngl(gm(i)+0.946548309d0*efield(i)), &
               sngl(gm(i)+15.0240129d0*efield(i)),sngl(gm(i)+3.7508458d0*efield(i))

        if(nst.ge.curon.and.nst.le.curof) &
        write(206,'(3es14.5)') sngl((alt(i)+alt(i+1))/2.0),sngl((GLL(i)+GLL(i+1))*57.29578/2.0), &
               sngl(curt(i))

        if(nst.ge.hotpon.and.nst.le.hotpof) &
        write(207,'(8es14.5)') sngl((alt(i)+alt(i+1))/2.0),sngl((GLL(i)+GLL(i+1))*57.29578/2.0), &
               sngl(den_p(i)),sngl(tpr_p(i)),sngl(tpp_p(i)), &
               sngl(den_hote(i)),sngl(tpr_hote(i)),sngl(tpp_hote(i))

        if(nst.ge.waveon.and.nst.le.waveof) &
        write(208,'(5es14.5)') sngl((alt(i)+alt(i+1))/2.0),sngl((GLL(i)+GLL(i+1))*57.29578/2.0), &
               sngl(dppo(i)),sngl(dpph(i)),sngl(dpphe(i))
    enddo


      !j=0
    !do i=1,imax_O
     !   s=Hydrog(i,1)
      !  if(s.ge.sg(23).and.s.lt.sg(24)) then
       !     j=j+1
        !    write(210,'(i8,2es14.6)') j,Hydrog(i,2),Hydrog(i,3)
        !endif
    !enddo

    do i=201,210
        close(i)
    enddo

end subroutine

