!-----------------------------------------------------------------------
!  Output velocity distributios
!
!  Jiannan Tu 4/8/2010
!-----------------------------------------------------------------------
subroutine print_vdistr(vsvp_O,vss_O,vps_O,vsvp_H,vss_H,vps_H,vsvp_He, &
             vss_He,vps_He,nst)
    use gskparm

    integer nst,LNBLNK,jk,av

    real(8) vss_O(noss,100),vps_O(nosp,100),vsvp_O(nossm,nospm)
    real(8) vss_H(nhss,100),vps_H(nhsp,100),vsvp_H(nhssm,nhspm)
    real(8) vss_He(nhess,100),vps_He(nhesp,100),vsvp_He(nhessm,nhespm)

    CHARACTER fnum*5,suff*6,fn*256
    av=1 
    write(suff,'(i6)') nst; suff=adjustl(suff)      !CALL filesuffix(nst,suff)
     
!* O+ distribution function vs (s, vs); s: arc length along field line
    fn='/home/wangy/DyFk/PLOT/O-VSS-'//suff(:LNBLNK(suff))
    open(31,file=fn,status='unknown',form='unformatted')

    ! average f(s,vs) accumulated in jav time steps
    vss_O(1:noss,1:100)=vss_O(1:noss,1:100)/float(av)

    write(31) sngl(sg(1)),sngl(sg(num+1)),sngl(vss_O(1:noss,1:100))
    close(31)

!* O+ distribution function versus (s, vp)
    fn='/home/wangy/DyFk/PLOT/O-VPS-'//suff(:LNBLNK(suff))
    open(32,file=fn,status='unknown',form='unformatted')
   
    ! average f(s,vs) accumulated in jav+1 time steps
    vps_O(1:nosp,1:100)=vps_O(1:nosp,1:100)/float(av)

    write(32) sngl(sg(1)),sngl(sg(num+1)),sngl(vps_O(1:nosp,1:100))
    close(32)

!* H+ distribution function versus (s, vs)
    fn='/home/wangy/DyFk/PLOT/H-VSS-'//suff(:LNBLNK(suff))
    open(33,file=fn,status='unknown',form='unformatted')

    ! average f(s,vs) accumulated in jav+1 time steps
    vss_H(1:nhss,1:100)=vss_H(1:nhss,1:100)/float(av)

    write(33) sngl(sg(1)),sngl(sg(num+1)),sngl(vss_H(1:nhss,1:100))
    close(33)

!* H+ distribution function versus (s, vp)
    fn='/home/wangy/DyFk/PLOT/H-VPS-'//suff(:LNBLNK(suff))
    open(34,file=fn,status='unknown',form='unformatted')
  
    ! average f(s,vs) accumulated in jav+1 time steps
    vps_H(1:nhsp,1:100)=vps_H(1:nhsp,1:100)/float(av)

    write(34) sngl(sg(1)),sngl(sg(num+1)),sngl(vps_H(1:nhsp,1:100))
    close(34)

!* He+ distribution function versus (s, vs)
    fn='/home/wangy/DyFk/PLOT/He-VSS-'//suff(:LNBLNK(suff))
    open(35,file=fn,status='unknown',form='unformatted')

    ! average f(s,vs) accumulated in jav+1 time steps
    vss_He(1:nhess,1:100)=vss_He(1:nhess,1:100)/float(av)

    write(35) sngl(sg(1)),sngl(sg(num+1)),sngl(vss_He(1:nhess,1:100))
    close(35)

!* He+ distribution function versus (s, vp)
    fn='/home/wangy/DyFk/PLOT/He-VPS-'//suff(:LNBLNK(suff))
    open(36,file=fn,status='unknown',form='unformatted')
  
    ! average f(s,vs) accumulated in jav+1 time steps
    vps_He(1:nhesp,1:100)=vps_He(1:nhesp,1:100)/float(av)

    write(36) sngl(sg(1)),sngl(sg(num+1)),sngl(vps_He(1:nhesp,1:100))
    close(36)

!* f(vs, vp) for O+ in a number of secified regions
    fn='/home/wangy/DyFk/PLOT/O-VSVP-'//suff(:LNBLNK(suff))
    open(37,file=fn,status='unknown', &
         form='unformatted')

    ! Average O+ f(vs, vp) accumulated in jav time steps
    vsvp_O(1:noss,1:nosp)=vsvp_O(1:noss,1:nosp)/float(av)

    write(37) (sngl(vsvp_O(1:noss,jk))/(2.0*jk-1.0),jk=1,nosp)
    close(37)
	   
!* f(vs, vp) for H+ in a number of secified regions
    fn='/home/wangy/DyFk/PLOT/H-VSVP-'//suff(:LNBLNK(suff))
    open(38,file=fn,status='unknown', &
         form='unformatted')

    ! Average H+ f(vs, vp) accumulated in jav time steps
    vsvp_H(1:nhss,1:nhsp)=vsvp_H(1:nhss,1:nhsp)/float(av)

    write(38) (sngl(vsvp_H(1:nhss,jk))/(2.0*jk-1.0),jk=1,nhsp)
    close(38)

!* f(vs, vp) for He+ in a number of secified regions
    fn='/home/wangy/DyFk/PLOT/He-VSVP-'//suff(:LNBLNK(suff))
    open(39,file=fn,status='unknown', &
         form='unformatted')

    ! Average He+ f(vs, vp) accumulated in jav time steps
    vsvp_He(1:nhess,1:nhesp)=vsvp_He(1:nhess,1:nhesp)/float(av)

    write(39) (sngl(vsvp_He(1:nhess,jk))/(2.0*jk-1.0),jk=1,nhesp)
    close(39)

end subroutine
