!     
! File:   load_ptcl_mp.f90
! Author: wangy
! Initialize simulation particle distribution in one processor
!
! Created on August 4, 2010, 12:50 PM
!

Subroutine load_ptcl_mp(vel_s,tpp_s,tpr_s,imax_s,ns,OHgen)

    use gskparm
    include 'mpif.h'
    real*8 vel_s,tpp_s,tpr_s,ran2,Ts
    integer imax_s,ns,i,j
    real*8 OHgen(np,3)

    real*8 vs,ft,fs,ds,Re,vels,Vt,factor

    real*8 kbm(0:2)

    integer rank,ierr,status
    common /mpi/rank,ierr,status

! O+ mass 2.65676233e-26; H+ mass 1.67382304e-27; kb 1.38065e-23
! kbmO=kb/mO; kbmH=kb/mH
    data kbm/519.67389d0,8248.482468d0,2062.120617d0/
    data Re/6371.2d3/
     
    ds=(sg(rank+2)-sg(rank+1))/float(imax_s)
    Ts=(tpr_s+2*tpp_s)/3

    vels=vel_s/Re
    Vt=sqrt(2.0d0*kbm(ns)*Ts)/Re

    factor=Vt*5.0d0
    if(ns.eq.0) factor=Vt*10.0d0

! assign velocity from a Maxwell distribution. Include all particles
! (both vs >0 and < 0).
    do j=1,imax_s

        ! vs=vparmin+ran2()*(vparmax-vparmin).
        ! vparmin=-factor+vels; vparmax-vparmin=2*factor
11      vs=(-factor+vels)+2.0d0*ran2(iseed)*factor
        ft=ran2(iseed)
        fs=exp(-((vs-vels)/Vt)**2)

        if(ft.gt.fs) go to 11

        ! smoothly placing particles in the cell 1(or num)
        OHgen(j,1)=sg(rank+1)+float(j-1)*ds
        OHgen(j,2)=vs
        OHgen(j,3)=Vt*sqrt(-log(1.0d0-ran2(iseed)))

    enddo
    

END subroutine

