!     
! File:   tgsk_mp.f90
! Author: wangy
!
! Created on September 18, 2010, 1:55 PM
!

Subroutine tgsk_mp()
      use inparm
      use gskparm
      include 'mpif.h'

     
      real(8) Te(nc),Tn(nc) !,v_vol(100)

      real(8) poten(nc),efield(nc),curt(nc),dppo(nc),dpph(nc),dpphe(nc)

      real(8) Z(401),PCO,ZT

!      real(8) a,r_a,v_dr,v_con,r_b,b
      real(8) Req,sigma,pfreq,ggtemp,we0,curt0,DAR
      real(8) M_O,M_H,M_N2,M_O2,M_He,ak,Re,pi,degrad

      integer IDAY,i,j,err0,nume,num_s(3,num)
      integer jbn,jbs,nst,jmax,LNBLNK
 

      real AP(7),DEC,ETRAN,BLON,F107,F107A,SEC,GLATD,GLOND,SAT
      real(8) GL(401) !,energy

      real(4) UTSEC,atomD(8),atomT(2)
      logical first

      SAVE

      real(8) denO,velO,tprO,tppO,qprO,qppO
      real(8) denH,velH,tprH,tppH,qprH,qppH
      real(8) denHe,velHe,tprHe,tppHe
      real(8) qprHe,qppHe

      real(8) vss_O(noss,100),vps_O(nosp,100),vsvp_O(nossm,nospm)
      real(8) vss_H(nhss,100),vps_H(nhsp,100),vsvp_H(nhssm,nhspm)
      real(8) vss_He(nhess,100),vps_He(nhesp,100),vsvp_He(nhessm,nhespm)

      real(8) vss_O_tmp(noss,100),vps_O_tmp(nosp,100),vsvp_O_tmp(nossm,nospm)
      real(8) vss_H_tmp(nhss,100),vps_H_tmp(nhsp,100),vsvp_H_tmp(nhssm,nhspm)
      real(8) vss_He_tmp(nhess,100),vps_He_tmp(nhesp,100),vsvp_He_tmp(nhessm,nhespm)

      real(8) dummy1(np1,3),dummy2(np1,3),dummy4(np1,3),dummy5(np1,3)
      real(8) dummyp1(np1,3),dummyp2(np1,3),dummyp4(np1,3),dummyp5(np1,3)

!  pass mpi parameter
      integer rank,ierr,status
      common /mpi/rank,ierr,status

!  pass geophysical condition from FLIP
      COMMON/MSIS/AP,DEC,ETRAN,BLON,F107,F107A,IDAY,SEC,GL

      data M_O/2.65676233d-26/,M_H/1.67382304d-27/,M_N2/4.65174685d-26/
      data M_O2/5.3135247d-26/,Re/6371.2e3/,ak/1.38065d-23/
      data M_He/6.69529216d-27/,first/.true./
      data sigma/1.5d-15/

      print*, 'rank=',rank,'finish defining variables in GSK'

!**************** Broadcast parameters obtained from FLIP **********************
 
      call MPI_BCAST(nst,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)           
      call MPI_BCAST(jmax,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr) 
      !print *,'rank=',rank,'jmax=',jmax,'nst=',nst
      !pause
      call MPI_BCAST(Z,401,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      call MPI_BCAST(ZT,1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      !print*,'Z(1)=',Z(1),'Z(10)=',Z(10),'Z(100)=',Z(100),'Z(400)=',Z(400)
      !print*,'rank=',rank,'&ZT=',ZT,'MPI_COMM_WORLD=',MPI_COMM_WORLD
      !pause
      call MPI_BCAST(PCO,1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      call MPI_BCAST(AP,7,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      !print *, 'rank=',rank,'PCO=',PCO
      !print *, 'rank=',rank,'AP=',AP
      !pause
      call MPI_BCAST(DEC,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      !print *,'rank=',rank,'PCO=',PCO,'DEC=',DEC
      !pause
      call MPI_BCAST(ETRAN,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      call MPI_BCAST(BLON,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      call MPI_BCAST(F107,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      call MPI_BCAST(F107A,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      !print *,'rank=',rank,'ETRAN=',ETRAN,'&BLON=',BLON,'&F107A=',F107A,'&F107=',F107
      CALL MPI_BCAST(SEC,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(GLATD,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(GLOND,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(SAT,1,MPI_REAL,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(GL,401,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      !print *,'rank=',rank,'&SEC=',SEC,'&GLATD=',GLATD,'&GLOND=',GLOND,'&SAT=',SAT,'&GL=',GL
      print *, 'rank=', rank, 'finish first broadcast parameters from Flip in GSK here'

      err0=0
     
      UTSEC=mod(int(SEC), 86400)
           
      dppo=-1.0d0; dpph=-1.0d0; dpphe=-1.0d0

! Req: L-shell. PCO varying if flux tube drifts
      Req=PCO

! zero elements of various arrays
      !call init_array2(denO,velO,tprO,tppO,qprO,qppO,denH,velH,tprH, &
      !                 tppH,qprH,qppH,denHe,velHe,tprHe,tppHe,qprHe,qppHe)
      call init_array3(vsvp_O_tmp,vss_O_tmp,vps_O_tmp,vsvp_H_tmp,&
                       vss_H_tmp,vps_H_tmp,vsvp_He_tmp,vss_He_tmp,vps_He_tmp)

! determine grid indice for GSK bottom boundaries in FLIP zone
      do j=1,JMAX/2
        if(Z(j).ge.zb) then
          jbn=j-1
          exit
        endif
      enddo
      do j=JMAX,JMAX/2,-1
        if(Z(j).ge.zb) then
          jbs=j+1
          exit
        endif
      enddo

! calculate q values from N to S in GSK zone
      call qvalue(num,Req,Z,scalg,jbn,qval)

! calcualte grid parameters along the flux tube
      call calc_grid(nst,Req)

! determine grid indice for FLIP top boundaries in GSK zone
      do j=1,num/2+1
        if(alt(j).ge.zt) then
          jgfn=j-1
          exit
        endif
      enddo
      do j=num+1,num/2+1,-1
        if(alt(j).ge.zt) then
          jgfs=j+1
          exit
        endif
      enddo

      print *,'nst=', nst, 'rank=', rank, ' finish grid calculation'


      if(first.or.Drift.eq.'Yes') then
         call MPI_BCAST(we0,1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(Veq,1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(curt0,1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
         Veq=Veq/Re    !convert to unit of Re/s
         Veq2=Veq*Veq
      endif

      print *, 'nst=', nst, 'rank=', rank, 'finished second BCAST in GSK'

       if(first) then
          call init_array1()
          call init_array4()

          pi=acos(-1.0d0)
          degrad=pi/180.0d0

        !Ionization frequency (Schunk & Nagy, Ionospheres, Chap 9, p. 245,
        !Table 9.2): = 2.44d-7/s in solar min;  = 6.346d-7/s in solar max
          if(F107.gt.130) pfreq=6.346d-7
          if(F107.le.130) pfreq=2.44d-7

!         call MPI_BARRIER(MPI_COMM_WORLD,ierr)

        ! read collision cross sections for O+ (with O, N2 and O2)
          call MPI_BCAST(ggtemp,1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)

	  call MPI_BCAST(gg_sig,2*326,MPI_REAL8,0,MPI_COMM_WORLD,ierr)

          print *, 'nst=', nst, 'rank=', rank, 'finished third BCAST in GSK'

          ! input particles from files
          call read_ptcl(err0,rank)
          print *, 'nst=', nst, 'rank=', rank, 'finished reading particles from file in GSK'
!          pause

!          call MPI_BARRIER(MPI_COMM_WORLD,ierr)

         select case (err0)
           case (0)

            call MPI_BCAST(den_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(Te,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpr_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpp_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(vel_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(efield,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
            call MPI_BCAST(den_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
            call MPI_BCAST(vel_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpr_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpp_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(den_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(vel_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpr_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpp_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(den_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(vel_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpr_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpp_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(qpr_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(qpp_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(qpr_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(qpp_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(qpr_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(qpp_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(qpr_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(qpp_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)

            print *, 'nst=', nst, 'rank=', rank, 'finished fourth BCAST in GSK'

           case (-1) !fail to input ptcls
            ! start a new GSK run --> initialize ptcl distributions
            ! get initial e-, O+, H+ & He+ density, velocity, and temperature
            ! distributions based on the distributions from FLIP solution

	    call MPI_BCAST(den_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(vel_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)			
	    call MPI_BCAST(tpr_e,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)		

	    call MPI_BCAST(den_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(vel_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpr_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)

	    call MPI_BCAST(den_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(vel_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpr_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
			
	    call MPI_BCAST(den_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(vel_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	    call MPI_BCAST(tpr_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)			

            print *, 'nst=', nst, 'rank=', rank, 'finished fourth* BCAST in GSK'

            tpp_e=tpr_e; tpp_O=tpr_O; tpp_H=tpr_H; tpp_He=tpr_He
  
            ! load O+, H+ & He+ assuming isotropic & drifitng Maxwell distri
            call load_ptcl(den_O,ndO,0,rep_O,num_s)
            call load_ptcl(den_H,ndH,1,rep_H,num_s)
            call load_ptcl(den_He,ndHe,2,rep_He,num_s)

            imax_O=num_s(1,rank+1)
            imax_H=num_s(2,rank+1)
            imax_He=num_s(3,rank+1)

            print *, 'nst=', nst, 'rank=', rank, 'finished load ptcl in GSK'
!            print *, 'nst,rank,imax_O,imax_H,imax_He:',nst,rank,imax_O,imax_H,imax_He

     
            call load_ptcl_mp(vel_O(rank+1),tpp_O(rank+1),tpr_O(rank+1),imax_O,0,Oxygen)  
            call load_ptcl_mp(vel_H(rank+1),tpp_H(rank+1),tpr_H(rank+1),imax_H,1,Hydrog)
            call load_ptcl_mp(vel_He(rank+1),tpp_He(rank+1),tpr_He(rank+1),imax_He,2,Helium) 

            print *, 'nst=', nst, 'rank=', rank, 'finished load ptcl-mp in GSK'

        end select
            ! initial electric field     
            call efdfind(efield,poten)

           ! make sure no more initialization
             first=.false.
       endif

!**************************** Calculate moments at current time step *********************
        call moments_s(Oxygen,imax_O,rep_O,denO,velO,tprO,tppO,qprO,qppO,0)
        print *, 'nst=', nst, 'rank=', rank, 'finished moments_s O+ in GSK'

        call moments_s(Hydrog,imax_H,rep_H,denH,velH,tprH,tppH,qprH,qppH,1)
        print *, 'nst=', nst, 'rank=', rank, 'finished moments_s H+ in GSK'

        call moments_s(Helium,imax_He,rep_He,denHe,velHe,tprHe,tppHe,qprHe,qppHe,2)
        print *, 'nst=', nst, 'rank=', rank, 'finished moments_s He+ in GSK'
        call MPI_BARRIER(MPI_COMM_WORLD,ierr)

!***************Gather the moments of all grids*******************************
        call MPI_ALLGATHER(denO,1,MPI_REAL8,den_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(velO,1,MPI_REAL8,vel_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tprO,1,MPI_REAL8,tpr_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tppO,1,MPI_REAL8,tpp_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qprO,1,MPI_REAL8,qpr_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qppO,1,MPI_REAL8,qpp_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)

        call MPI_ALLGATHER(denH,1,MPI_REAL8,den_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(velH,1,MPI_REAL8,vel_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tprH,1,MPI_REAL8,tpr_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tppH,1,MPI_REAL8,tpp_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qprH,1,MPI_REAL8,qpr_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qppH,1,MPI_REAL8,qpp_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
  
        call MPI_ALLGATHER(denHe,1,MPI_REAL8,den_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(velHe,1,MPI_REAL8,vel_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tprHe,1,MPI_REAL8,tpr_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tppHe,1,MPI_REAL8,tpp_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qprHe,1,MPI_REAL8,qpr_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qppHe,1,MPI_REAL8,qpp_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)

   
!****************** smooth moments (density, velocity & temperature)**************
        call smooth10(num)


      CALL MPI_BCAST(P_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(P_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(P_O_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(P_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(atom_s,4*nc,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(den_aO,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(vt_O,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(vt_H,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(vt_N2,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(vt_O2,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(vt_He,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(pol_N2,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
      CALL MPI_BCAST(Tn,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)

      print *, 'nst=', nst, 'rank=', rank, 'finished fifth BCAST in GSK'

      ! added by X.Y.Wu 03/05/98 wave heating rate profile
      if (nst.ge.WAVEON.and.nst.le.WAVEOF) then
        call waveh_rate(we0,dppo,dpph,dpphe)        
      else
          dppo=-1.0d0
          dpph=-1.0d0
          dpphe=-1.0d0
      endif

      if(nst==HOTPON) then
         nume=num/2+1

         call MPI_BCAST(den_p,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(tpp_p,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	 call MPI_BCAST(tpr_p,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	 call MPI_BCAST(tpp_hote,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
	 call MPI_BCAST(tpr_hote,num+1,MPI_REAL8,0,MPI_COMM_WORLD,ierr)

         print *, 'nst=', nst, 'rank=', rank, 'finished  BCAST in GSK'

         DAR=(tpp_p(nume)/tpr_p(nume))/(tpp_hote(nume)/tpr_hote(nume))
      endif

      if(nst.ge.CURON.and.nst.le.CUROF) then

      else
         curt0=0.0d0
      endif
      do i=1,num+1
          curt(i)=curt0*(rr(i)/rr(num+1))**3
      enddo


      if(rank.eq.num-1) then

          CALL MPI_RECV(bottom_upO,2,MPI_INTEGER,0,1,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(bottom_upH,2,MPI_INTEGER,0,2,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(bottom_upHe,2,MPI_INTEGER,0,3,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(factorO,2,MPI_REAL8,0,4,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(factorH,2,MPI_REAL8,0,5,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(factorHe,2,MPI_REAL8,0,6,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(fmaxO,2,MPI_REAL8,0,7,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(fmaxH,2,MPI_REAL8,0,8,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(fmaxHe,2,MPI_REAL8,0,9,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(FV_O,2,MPI_REAL8,0,10,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(FV_H,2,MPI_REAL8,0,11,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(FV_He,2,MPI_REAL8,0,12,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(vtprO,2,MPI_REAL8,0,13,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(VtppO,2,MPI_REAL8,0,14,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(vtprH,2,MPI_REAL8,0,15,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(VtppH,2,MPI_REAL8,0,16,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(vtprHe,2,MPI_REAL8,0,17,MPI_COMM_WORLD,status,ierr)
          CALL MPI_RECV(VtppHe,2,MPI_REAL8,0,18,MPI_COMM_WORLD,status,ierr)

          print *, 'nst=', nst, 'rank=', rank, 'finished RECV in GSK'
     endif

   call MPI_BCAST(FheatE,2,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
   print *, 'nst=', nst, 'rank=', rank, 'finished sixth BCAST in GSK' 

   do j=1,loopmax


      
!*********************************************************************************
!                                Start main loop
!*********************************************************************************

        
      call MPI_BARRIER(MPI_COMM_WORLD,ierr)  !synchronize

      !First conduct Coulomb collisions
      call coulomb_coll() !(energy)
      call MPI_BARRIER(MPI_COMM_WORLD,ierr)  !synchronize

      print *, 'nst=', nst, 'j=',j,'rank=', rank, 'finished collision in GSK'
!**************************** Calculate moments at current time step *********************
        call moments_s(Oxygen,imax_O,rep_O,denO,velO,tprO,tppO,qprO,qppO,0)
        print *, 'nst=', nst, 'rank=', rank, 'finished moments_s O+ in GSK'

        call moments_s(Hydrog,imax_H,rep_H,denH,velH,tprH,tppH,qprH,qppH,1)
        print *, 'nst=', nst, 'rank=', rank, 'finished moments_s H+ in GSK'

        call moments_s(Helium,imax_He,rep_He,denHe,velHe,tprHe,tppHe,qprHe,qppHe,2)
        print *, 'nst=', nst, 'rank=', rank, 'finished moments_s He+ in GSK'
        call MPI_BARRIER(MPI_COMM_WORLD,ierr)

!***************Gather the moments of all grids*******************************
        call MPI_ALLGATHER(denO,1,MPI_REAL8,den_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(velO,1,MPI_REAL8,vel_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tprO,1,MPI_REAL8,tpr_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tppO,1,MPI_REAL8,tpp_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qprO,1,MPI_REAL8,qpr_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qppO,1,MPI_REAL8,qpp_O,1,MPI_REAL8,MPI_COMM_WORLD,ierr)

        call MPI_ALLGATHER(denH,1,MPI_REAL8,den_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(velH,1,MPI_REAL8,vel_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tprH,1,MPI_REAL8,tpr_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tppH,1,MPI_REAL8,tpp_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qprH,1,MPI_REAL8,qpr_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qppH,1,MPI_REAL8,qpp_H,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
  
        call MPI_ALLGATHER(denHe,1,MPI_REAL8,den_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(velHe,1,MPI_REAL8,vel_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tprHe,1,MPI_REAL8,tpr_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(tppHe,1,MPI_REAL8,tpp_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qprHe,1,MPI_REAL8,qpr_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)
        call MPI_ALLGATHER(qppHe,1,MPI_REAL8,qpp_He,1,MPI_REAL8,MPI_COMM_WORLD,ierr)

        call smooth10(num)

 

        ! Calculate electon temp using Titherodge equation if ele=0
        select case (eqe)
            case (1)
                call ele_fluid(dtg,num+1,fheate,curt,Te)
            case default
                CALL ele_den(num+1)
                CALL ele_vel(num+1,curt)

                call Titheridge_Te(Req,Te)
                tpr_e=Te
                tpp_e=Te
        end select

        print *, 'nst=', nst, 'rank=', rank, 'finished ele_fluid in GSK'
        !call MPI_BARRIER(MPI_COMM_WORLD,ierr)
        !pause

        !  XYWU mapping magnetospheric component 12/15/99
        if(nst.ge.HOTPON.and.nst.le.HOTPOF) then
          call Liouville(num,poten)

          den_hote=den_O+den_H+den_He+den_p-den_e
        else
          call init_array4()
        endif

        ! update electric field
        call efdfind(efield,poten)
        print *, 'nst=', nst, 'rank=', rank, 'finished efdfind in GSK'
        !call MPI_BARRIER(MPI_COMM_WORLD,ierr)
        !pause

     enddo

         if(mod(nst,iout).eq.0) then
            !call write_ptcl(rank)
            print *, 'nst=', nst, 'rank=', rank, 'finished write ptcl in GSK'
         endif

       
         call MPI_BARRIER(MPI_COMM_WORLD,ierr)

     

end Subroutine tgsk_mp



